// -*- tab-width:2 ; indent-tabs-mode:nil -*-
//:: case FutureQueueApplication

//begin(all)
public class AbstractFutureQueue {

// begin(get)
//@ Future fut;
//@ boolean fut_active;
// end(get)

  /*@ given Future fut;
   requires HPerm(fut.q,1) ** fut.q==seq<int>{};
   ensures Value(this.fut) ** this.fut == fut
     ** PointsTo(fut_active,1/2,true); @*/
  public AbstractFutureQueue(){
    //@ assume false;
  }
  

  /*@
    given frac p;
    given process P;
    requires Value(fut) ** p!=none
      ** PointsTo(fut_active,p/2,true) ** Future(fut,p,fut.put(val)*P);
    ensures  Value(fut) ** p!=none
      ** PointsTo(fut_active,p/2,true) ** Future(fut,p,P);
  @*/
  public void put(int val);

// begin(get)
/*@ given frac p;   given process P;
    given int val;
      requires Value(fut) ** Future(fut,p,fut.get(val)*P)
         ** p!=none ** PointsTo(fut_active,p/2,true);
      ensures  Value(fut) ** Future(fut,p,P)
         ** p!=none ** PointsTo(fut_active,p/2,true) ** \result == val;
@*/ public int get();
// end(get)

/*@
  requires Value(fut) ** PointsTo(fut_active,1/2,true);
  ensures Value(fut)  ** PointsTo(fut_active,1/2,false)** HPerm(fut.q,1);
  void end_future();
@*/
  
}
//end(all)

