// -*- tab-width:2 ; indent-tabs-mode:nil -*-
//:: case QueueApplication
//:: tool silicon
//:: options --check-history

/* To verify this example:

  vct --silver=silicon_qp --check-history HistoryQueue.java SpecifiedThread.java HistoryWorker.java AbstractQueue.java HistoryMain.java
  
 */
//begin(all)
public class Main {


  /*@
    given seq<int> contents;
    requires input.length==|contents|;
    requires output.length==|contents|;
    requires (\forall* int i; 0 <= i && i < |contents|;Perm(input[i],1));
    requires (\forall  int i; 0 <= i && i < |contents|;input[i]==contents[i]);
    requires (\forall* int i; 0 <= i && i < |contents|;Perm(output[i],1));
    requires (\forall  int i; 0 <= i && i < |contents|;output[i]==0);
  @*/
  public static void main(int[] input,int[] output){
    History hist=new History();
    //@ hist.q = seq<int>{};
    //@ create hist;
    AbstractQueue q=new AbstractQueue()
    /*@ with { hist=hist; } @*/;
    //@ split q.hist, 1/2, empty, 1/2, empty;

    
    Sender   s=new Sender(q,input)/*@ with {vals=contents;} @*/;
    Receiver r=new Receiver(q,output);
    r.start();
    s.start();

    s.join()/*@ with { p = 1; } @*/;
    //@ open s.postJoin@Sender(1);
    //@ unfold s.postJoin@Sender(1);
   
    r.join()/*@ with { p = 1; } @*/;
    //@ open r.postJoin@Receiver(1);
    //@ unfold r.postJoin@Receiver(1);
  
    //@ assert Hist(hist,1/2,hist.put_all(s.vals));
    //@ assert Hist(hist,1/2,hist.get_all(r.vals));
    
    //@ merge hist, 1/2, hist.put_all(s.vals), 1/2, hist.get_all(r.vals);
    //@ q.end_history();
    //@ destroy hist, hist.feed(s.vals,r.vals);

    // Derive some intermediate results.
    //@ assert seq<int>{} + s.vals == r.vals + hist.q;
    //@ assert hist.q == seq<int>{};
    // Assume a few extra rules about seqeunces.
    //@ assume (\forall seq<int> L; true ; seq<int>{} + L == L );
    //@ assume (\forall seq<int> L; true ; L + seq<int>{} == L );
    // Verify that the input and output are equal.
    //@ assert s.vals == r.vals;
  }
}
//end(all)


