// -*- tab-width:2 ; indent-tabs-mode:nil -*-
//:: case PingPongFuture
//:: tool silicon
//:: option --check-history

/**
  This example shows how to validate the ping/pong example with futures.
 */
public class Future {/*@
    boolean b;
    
    modifies b;
    ensures  !\old(b) && b;
    process  ping();

    modifies b;
    ensures  b;
    process  ping_omega()=ping()*ping_omega();

    ensures ping_omega()*ping()==ping_omega();
    void ping_axiom_1();
   
@*/
}

class AtomicBoolean {

  boolean val;

  void set(boolean v){ this.val=v; }
  
  boolean get(){ return this.val; }
	
	boolean compareAndSet(boolean x, boolean v){
		boolean res=(this.val==x);
		if(res) {
			this.val=v;
		}
		return res;
	}

  /*@
    ensures PointsTo(val,1,v);
  @*/
  public AtomicNode(boolean v){
    this.val=v;
  }
}

class Invariant {

  //@ Future fut;
  public AtomicBoolean b;
  /*@
    resource csl_invariant()=Value(b) ** Perm(b.val,1) ** Value(fut) ** HPerm(fut.b,1) ** b.val==fut.b;
  @*/
  
  public Invariant(){
    //@ assume false;
    //b=new AtomicBoolean(false);
  }
}

class Ping {

  //@ Invariant inv;
  AtomicBoolean b;

  /*@
     inline resource common()=Value(b) ** Value(inv) ** Value(inv.b) ** b == inv.b **
       Value(inv.fut);
  @*/

  /*@
    requires common() ** Future(inv.fut,1/2,inv.fut.ping_omega());
  @*/
  void run(){
    //@ loop_invariant common() ** Future(inv.fut,1/2,inv.fut.ping_omega());
    while(true){
      ping();
    }
  }
  
  /*@
    requires common() ** Future(inv.fut,1/2,inv.fut.ping_omega());
    ensures  common() ** Future(inv.fut,1/2,inv.fut.ping_omega());
  @*/
  void ping(){
    boolean tmp=false;
    //@ loop_invariant common();
    //@ loop_invariant Future(inv.fut,1/2,inv.fut.ping_omega());
    while(!tmp){
      tmp=b.compareAndSet(false,true)/*@
        with {
          csl_subject inv;
          if (b.val==false){
            { action inv.fut,1/2,inv.fut.ping_omega(),inv.fut.ping() ; inv.fut.b=true; }
          }
        }
      @*/;
    }
  }

}


