import mpi.MPI;

public class MPAOMain {
    public static void main(String[] args) {
        MPI.Init(args);
        MPAO.init();

        if (MPAO.getWorkerId() == 0) {
            System.out.println("Getting Math object...");
            RemoteFuture<MathRemote> f = MPAO.getFactory(1).newMath();
            System.out.println("Request sent.");
            MathRemote math = f.get();
            System.out.println("Got Math object.");

            System.out.println("Calculating 2 + 3...");
            RemoteFuture<Integer> result = math.divide(6, 2);
            System.out.println("Request sent.");
            System.out.println("6 / 2 = " + result.get());
        }

        MPI.COMM_WORLD.Barrier();
        MPI.Finalize();
        System.exit(0);
    }
}
