import mpi.MPI;

public class MPAOMainSingle {
    public static void main(String[] args) {
        Future fut = new Future();

        MPI.Init(args);
        MPAO.init();

        if (MPAO.getWorkerId() == 0) {
            //@ create fut, fut.add(0, 1, 2, 3);
            MathRemote math = new MathRemote(1, 0);

            System.out.println("Calculating 6 / 2...");
            RemoteFuture<Integer> result = math.divide(6, 2);
            System.out.println("Request sent.");
            System.out.println("6 / 2 = " + result.get());
            //@ destroy fut;
        } else {
            //@ create fut, fut.objectLoopMath(1);
            MathImpl local = new MathImpl(0);
            local.run();
            //@ destroy fut;
        }

        MPI.COMM_WORLD.Barrier();
        MPI.Finalize();
        System.exit(0);
    }
}
