//:: cases MathActiveObject
//:: tools silicon
//:: verdict Pass

/* To verify this example:

  vct --silver=silicon --check-history dummy/Future.java dummy/mpi/{Status,Datatype,Request,Intracomm}.java dummy/MPIWrapper.java src/MathActiveObject.java

 */

import mpi.Intracomm;
import mpi.Status;

public class MathActiveObject {
    /*@
        given Future fut;
        given frac p;
        given process P;
        given int r1;
        given int r2;
        requires fut != null ** p != none;
        requires Future(fut, p, fut.recv(0, 1, recvbuf, 0, r1) *
                                fut.isend(1, 0, sendbuf, 1, r2) *
                                P);
        ensures Future(fut, p, P);
    @*/
    public void receiveCall(Object recvbuf, Object sendbuf) {
        //Object[] recvbuf = new Object[1];

        MPIWrapper mpi = new MPIWrapper();
        Intracomm COMM_WORLD = mpi.COMM_WORLD();

        //@ assume COMM_WORLD.Rank() == 1;

        Status s = COMM_WORLD.Recv(recvbuf, 0, 1, mpi.OBJECT(), 0, 0)
        /*@ with {fut = fut; p = p; P = fut.isend(1, 0, sendbuf, 1, r2) * P; r = r1;} @*/;
        //@ assume s.source == 0;

        // unpacking
        int source = s.source;
        /*
        Call call = (Call) recvbuf[0];
        int a = (int) call.getParameters()[0];
        int b = (int) call.getParameters()[1];
        //@ assume b != 0 ** a % b == 0;

        int res = divide(a, b);
        //@ assert res * b == a;

        Object[] sendbuf = new Object[]{res};
        */

        COMM_WORLD.Send(sendbuf, 0, 1, mpi.OBJECT(), source, 1)
        /*@ with {fut = fut; p = p; P = P; r = r2;} @*/;

        //@ refute false;
    }

    /*@
        requires b != 0 ** a % b == 0;
        ensures \result * b == a;
    @*/
    public int divide(int a, int b) {
        return a / b;
    }
}
