public class ReceivedCall {
    private final int source;
    private final Call call;

    /*@
        int objectId;
        public resource valid() =
                Value(this.source) ** Value(this.call) **
                Value(this.objectId) **
                valid(this.source, Rank(), call, objectId);
    @*/

    /*@
        given int objectId;
        requires valid(source, Rank(), call, objectId);
        ensures Value(this.source) ** this.source == source;
        ensures Value(this.call) ** this.call == call;
        ensures valid();
    @*/
    public ReceivedCall(int source, Call call) {
        this.source = source;
        this.call = call;
        //@ this.objectId = objectId;
        //@ fold valid();
    }

    /*@
        requires valid();
        ensures \result == this.call;
        ensures valid(this.source, Rank(), \result, objectId);
    @*/
    public Call getCall() {
        return this.call;
    }

    /*@
        requires Value(this.source);
        ensures \result == this.source;
    @*/
    public int getSource() {
        return this.source;
    }

    @Override
    public String toString() {
        return call + " from " + source;
    }
}
